\version "2.13.0"
leiser = { \dimTextDecresc 
  \once\override DynamicTextSpanner #'dash-period = #-1.0 
} 
gabel = { \crescHairpin \dimHairpin  } 
%danach eingeben: \>, nicht vergessen, \dimHairpin danach einzugeben 
lauter = { \crescTextCresc 
  \once \override DynamicTextSpanner #'dash-period = #-1.0  
}
% danach \crescHairpin eingeben!
%Dynammik, crescendo und som Zeugs
%%%% Einfaches decrescendo
dcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0  \> >> \gabel
  #})
  %%% einfaches Crescendo:
  cr = #(define-music-function (parser location x) (ly:music?)
  #{ \lauter
    \context Voice <<        $x  s1*0  \< >> \gabel
    #})
  
fcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \f \> >> \gabel
#})

ppcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \pp \< >> \gabel
#})

pcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \p \< >> \gabel
#})

mpcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \mp \< >> \gabel
#})

mfcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \mf \< >> \gabel
#})

fcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \f \< >> \gabel
#})

ffcr = #(define-music-function (parser location x) (ly:music?)
#{ \lauter
  \context Voice <<        $x  s1*0 \ff \< >> \gabel
#})

ppdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \pp \> >> \gabel
#})

pdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \p \> >> \gabel
#})

mpdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \mp \> >> \gabel
#})

mfdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \mf \> >> \gabel
#})

fdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \f \> >> \gabel
#})

ffdcr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \ff \> >> \gabel
#})


decr = #(define-music-function (parser location x) (ly:music?)
#{ \leiser
  \context Voice <<        $x  s1*0 \> >> \gabel
  #})
  
  
  hairpinWithCenteredText = #(define-music-function (parser location text) (markup?)
  #{
    \override Voice.Hairpin #'stencil = #(lambda (grob)
    (ly:stencil-aligned-to
    (ly:stencil-combine-at-edge
    (ly:stencil-aligned-to (ly:hairpin::print grob) X CENTER)
    Y DOWN
    (ly:stencil-aligned-to (ly:text-interface::print grob) X CENTER))
    X LEFT))
    \override Voice.Hairpin #'text = $text
  #})

  hairpinMolto = \hairpinWithCenteredText \markup { \italic molto }
  hairpinMore = \hairpinWithCenteredText \markup { \italic moltissimo }

  
%%%%%% Dynamik, die auch Textanteile enthält:
dolce  = \markup{\italic dolce}
espr   = \markup{\italic espr.}
piu = \markup{\italic "più" }
legato = \markup{\italic legato}
cantabile = \markup{\italic cantabile}
sempre = \markup{\italic sempre}
martellato = \markup{\italic martellato}
nonlegato = \markup{\italic "non legato" }
sub = \markup{\italic "sub."}
%%% eine zusammengesetzte Dynamik wird definiert
#(define (make-dynamic-extra dynamic string)
     (make-music
       'AbsoluteDynamicEvent
       'tweaks
	 ;; calculate centering for text
	 (list (cons (quote X-offset)
	   (+ -0.5 (* -0.5 (string-length dynamic)))))
       'text
	 (markup
	   ;; uncomment next line for debugging
	   ;;#:box
	   #:line(
	       dynamic
	       #:hspace -0.3
	       #:normal-text #:italic string))
      ))


fflegato = #(make-dynamic-extra "ff" "legato")
flegato  = #(make-dynamic-extra "f"  "legato")
mflegato = #(make-dynamic-extra "mf" "legato")
mplegato = #(make-dynamic-extra "mp" "legato")
plegato  = #(make-dynamic-extra "p"  "legato")
pplegato = #(make-dynamic-extra "pp" "legato")

ffnonlegato = #(make-dynamic-extra "ff" "nonlegato")
fnonlegato  = #(make-dynamic-extra "f"  "nonlegato")
mfnonlegato = #(make-dynamic-extra "mf" "nonlegato")
mpnonlegato = #(make-dynamic-extra "mp" "nonlegato")
pnonlegato  = #(make-dynamic-extra "p"  "nonlegato")
ppnonlegato = #(make-dynamic-extra "pp" "nonlegato")

ffmartellato = #(make-dynamic-extra "ff" "martellato")
fmartellato  = #(make-dynamic-extra "f"  "martellato")

ffdolce = #(make-dynamic-extra "ff" "dolce")
fdolce  = #(make-dynamic-extra "f"  "dolce")
mfdolce = #(make-dynamic-extra "mf" "dolce")
mpdolce = #(make-dynamic-extra "mp" "dolce")
pdolce  = #(make-dynamic-extra "p"  "dolce")
ppdolce = #(make-dynamic-extra "pp" "dolce")
pppdolce = #(make-dynamic-extra "ppp" "dolce")

ffespr = #(make-dynamic-extra "ff" "espr.")
fespr  = #(make-dynamic-extra "f"  "espr.")
mfespr = #(make-dynamic-extra "mf" "espr.")
mpespr = #(make-dynamic-extra "mp" "espr.")
pespr  = #(make-dynamic-extra "p"  "espr.")
ppespr = #(make-dynamic-extra "pp" "espr.")

ffsempre = #(make-dynamic-extra "ff" "sempre")
fsempre  = #(make-dynamic-extra "f"  "sempre")
mfsempre = #(make-dynamic-extra "mf" "sempre")
mpsempre = #(make-dynamic-extra "mp" "sempre")
psempre  = #(make-dynamic-extra "p"  "sempre")
ppsempre = #(make-dynamic-extra "pp" "sempre")

mfcantabile = #(make-dynamic-extra "mf" "cantabile")
mpcantabile = #(make-dynamic-extra "mp" "cantabile")
pcantabile  = #(make-dynamic-extra "p"  "cantabile")
ppcantabile = #(make-dynamic-extra "pp" "cantabile")

flegatoespr  = #(make-dynamic-extra "f"  "legato espr.")
mflegatoespr = #(make-dynamic-extra "mf" "legato espr.")

ffsub = #(make-dynamic-extra "ff" "sub")
fsub  = #(make-dynamic-extra "f"  "sub")
mfsub = #(make-dynamic-extra "mf" "sub")
mpsub = #(make-dynamic-extra "mp" "sub")
psub  = #(make-dynamic-extra "p"  "sub")
ppsub = #(make-dynamic-extra "pp" "sub")

fdolceespr = #(make-dynamic-extra "f" "dolce espr.")
sffz = #(make-dynamic-script "sffz")
ffz  = #(make-dynamic-script "ffz")
fp = #(make-dynamic-script "fp")
fpp = #(make-dynamic-script "fpp")
ffp = #(make-dynamic-script "ffp")
mfp = #(make-dynamic-script "mfp")

piup = \markup { \italic "più" \dynamic p }

%tempobezeichnungen, als textspanner; nie vergessen: davor und danach \startTextSpan und \stopTextSpan einfuegen
rit = {\override TextSpanner  #'style = #'dashed-line \textSpannerUp
     \override TextSpanner #'bound-details #'left #'text = \markup { \upright "rit" } }
rall = {\override TextSpanner  #'style = #'dashed-line \textSpannerUp
     \override TextSpanner #'bound-details #'left #'text = \markup { \upright "rall" } }
acc = {\override TextSpanner  #'style = #'dashed-line \textSpannerUp
     \override TextSpanner #'bound-details #'left #'text = \markup { \upright "accelerando" } }
moltorit = {\override TextSpanner  #'style = #'dashed-line \textSpannerUp
     \override TextSpanner #'bound-details #'left #'text = \markup { \upright "molto rit" } }
     
 %damit kann man einen Tempotext mit Metromomangabe erzeugen; z.B. \tempoMark "Andante" "4" "= 76"; klammern sind automatisch dabei
 %%%%%%%% Wichtig: %%%%%%%%%%%%
 % Dieser Befehl muss VOR der NOte stehen!
 
 tiewait = { \set tieWaitForNote = ##t }
 tienormal = { \set tieWaitForNote = ##f }

 
 
 
 
 
 



%triller mit Vorzeichen:
kreuztrill = {  \once \override TrillSpanner #'bound-details #'left #'text = 
#(markup #:line (#:halign -0.5 #:musicglyph "scripts.trill" #:teeny #:raise 0.65 #:sharp )) }

%fügt neben das Trillerzeichen ein Kreuz hinzu

btrill = { \once \override TrillSpanner #'bound-details #'left #'text = 
#(markup #:line (#:halign -0.5 #:musicglyph "scripts.trill" #:teeny #:raise 0.5 #:flat )) }
%fÃ¼gt neben das Trillerzeichen ein B hinzu!! Achtung: Wenn vorher ein TextSpan gestartet war, klappts nicht! Also vor dem TextSpan beginnen, dann gehts!

%balken, haelse

manualBeam =
#(define-music-function (parser location beg end)
                        (number? number?)
#{
  \once \override Beam #'positions = #(cons $beg $end)
#})
%funktioniert dann z.b. so: /manualBeam #3 #6  
% Diese Funktion ist dazu da, die Balkenneigung zu verändern! Das ist ne ganz praktische Sache
ohnehals = { \override Stem  #'transparent = ##t }
mithals = {\override Stem  #'transparent = ##f }
%vorzeichen
kreuzAn = { 
#(set-accidental-style 'neo-modern)
} 
%jedes Vorzeichen wird gezeigt. Aber Achtung: Funktioniert nicht bei Akkorden, wenn cis und c in unterschiedlichen Oktaven sind!
%laesst sich aber mitten im Takt an- und abstellen!!! 
kreuzAus = { 
\set Staff.extraNatural = ##f
\unset Staff.autoAccidentals } %wieder wie vorher, konventionelle Vorzeichenbehandlung
% jetzt ein makro, bei dem alle Vorzeichen, auch Auflösungszeichen, gesetzt werden:
webernAccidentals = {
    % the 5s are just "a value different from any accidental"
    \set Staff.keySignature = #'((0 . 5) (1 . 5) (2 . 5) (3 . 5)
                                 (4 . 5) (5 . 5) (6 . 5))
    \set Staff.extraNatural = ##f
    #(set-accidental-style 'forget)
}
%% Achtung: erfordert, dass die Vorlage "moderne Partitur" geladen ist!
%Bzw. muss im Laypout-Block stehen:
% \context { \Staff \remove Key_engraver } 
%Rückgängig mit:
keinwebern = { \unset Staff.keySignature }

%%%% Wiederholungskuerzel%%%%%%%%
%ausgeschriebene Wiederholung
rr = #(define-music-function (parser location num music)(number? ly:music?)
#{ \repeat unfold $num $music #})
%funktioniert dann zb. so \rr #15 c
%%% übrigens: wenn da nur eine Note nach dem Befehl kommt, brauchts keine Klammer
%Tremolo
trem = #(define-music-function (parser location num music)(number? ly:music?)
#{ \repeat tremolo $num $music #}) 

%% Jetz kommt ne geile Geschichte, die es erlaubt, einen ganzen schwarm von Noten mit staccatopunkten zu 
%% versehen

#(define tieEvent? #f)
 
#(define (add-Staccato music)
 (let (
    (eventname (ly:music-property  music 'name))
    (elts (ly:music-property music 'elements))
    (elt  (ly:music-property music 'element))
 )
 (cond
    ((pair? elts)
        (begin
            (if (and
                    (eq? eventname 'EventChord)
                    (eq? (ly:music-property (car elts) 'name) 'NoteEvent)
                    (not tieEvent?)
                 )   
                (set! (ly:music-property music 'elements)
                        (append elts (list (make-music 'ArticulationEvent 'articulation-type "staccato"))))
                (set! tieEvent? #f)  
            )
            (map add-Staccato elts)
        )
    )
    ((ly:music? elt) (add-Staccato elt))
    ((eq? eventname 'TieEvent) (set! tieEvent? #t))
 ) 
 music
))
 
addStaccato = #(define-music-function (parser location music) (ly:music?)
 (set! tieEvent? #f)
 (add-Staccato music)

)

%%%%%%%%%%% Jetzt kommt dasselbe mit Tenuto: %%%%%%%%%%%%%%%%%%%%%%%%%%
#(define tieEvent? #f)
 
#(define (add-Tenuto music)
 (let (
    (eventname (ly:music-property  music 'name))
    (elts (ly:music-property music 'elements))
    (elt  (ly:music-property music 'element))
 )
 (cond
    ((pair? elts)
        (begin
            (if (and
                    (eq? eventname 'EventChord)
                    (eq? (ly:music-property (car elts) 'name) 'NoteEvent)
                    (not tieEvent?)
                 )   
                (set! (ly:music-property music 'elements)
                        (append elts (list (make-music 'ArticulationEvent 'articulation-type "tenuto"))))
                (set! tieEvent? #f)  
            )
            (map add-Tenuto elts)
        )
    )
    ((ly:music? elt) (add-Tenuto elt))
    ((eq? eventname 'TieEvent) (set! tieEvent? #t))
 ) 
 music
))
 
addTenuto = #(define-music-function (parser location music) (ly:music?)
 (set! tieEvent? #f)
 (add-Tenuto music)

)
 
%%%%% UNd mit Akzent:
#(define (addAccentFilterFunction event)
 (let ( (eventname (ly:music-property  event 'name)) )
  (if (eq? eventname 'EventChord)
    (let ( (elements (ly:music-property event 'elements)) )
      ; don't add accents to rests!
      (if (not (eq? (ly:music-property (car elements) 'name) 'RestEvent))
        (set! (ly:music-property event 'elements)
          (append elements (list (make-music 'ArticulationEvent 'articulation-type "accent"))
          ))))))
)

addAccent = #(define-music-function (parser location music) (ly:music?)
 (music-filter addAccentFilterFunction music)
)
% wenn man mal extraplatz fürn schlüsselwechsel braucht:
keyspace = 
{\once \override Staff.Clef #'X-extent = #'(-2 . 2) }
%%%%%%%%%%% Dynamik verschieben:
dynaweg = #(define-music-function (parser location staff-padding) (number?)
#{      
        \once \override DynamicLineSpanner #'cross-staff = ##t
         \once \override DynamicLineSpanner #'staff-padding = #$staff-padding
       #})
%%%%%%%% jetzt gibt man also ein, z.b.: \dynaweg #2 und die Dynamik rutscht ein bisschen weiter weg
dynaimmerweg = #(define-music-function (parser location staff-padding) (number?)
       #{
          \override DynamicLineSpanner #'staff-padding = #$staff-padding
        #})
%dasselbe wie vorher, nur jetzt gilts längerfristig.
% dynanormal = { \revert DynamicLineSpanner #'staff-padding  }

%jetzt dasselbe horizontal
dynarechts = #(define-music-function (parser location X-offset) (number?)
#{      
      \once  \override DynamicText #'X-offset = #$X-offset
       #})
       dynaimmerrechts = #(define-music-function (parser location X-offset) (number?)
#{      
        \override DynamicText #'X-offset = #$X-offset
       #})
       dynanormal = { \revert DynamicLineSpanner #'staff-padding \revert  DynamicText #'X-offset }
%Dasselbe jetzt mit Texten nach dem Markup-Kommando

%%%%%%%%%%%% Metronommarke verschieben:
metroweg = #(define-music-function (parser location padding) (number?)
       #{
         \once \override Score.MetronomeMark #'padding = #$padding
       #})
       
       %Für Mehrtaktpausen hat sich der Wert \metroweg #3.5 bewährt
       %%%%%%% Text Verschieben:
       
textweg = #(define-music-function (parser location staff-padding) (number?)
       #{ \override  TextScript #'cross-staff = ##t 
          \override TextScript #'staff-padding = #$staff-padding
       #})
    textnormal =  {  \revert TextScript #'staff-padding   }          
%%%%%%%%%%%%%%%%%%%%%% xtolen %%%%%%%%%%%%%%%%%%%%%%%%
klammernormal = {  \override TupletBracket #'bracket-visibility = #'if-no-beam }
% Klammer und Zahl werden  ganz normal gezeigt
klammeran =  { \override TupletBracket #'bracket-visibility = ##t }
klammeraus = { \override TupletBracket #'bracket-visibility = ##f }
mitzahl ={ \revert TupletNumber #'stencil }
ohnezahl = { \override TupletNumber #'stencil = ##f }

bruchan = { \override TupletNumber #'text = #tuplet-number::calc-fraction-text }
bruchaus = { \revert TupletNumber #'text }
standardxtol = { \klammernormal \mitzahl \bruchaus }
%die Zahl von der Xtole verschieben
tupletweg =
 #(define-music-function (parser location padding) (number?)
       #{ \once \override TupletNumber #'cross-staff = ##t
       \once \override TupletBracket #'padding = #$padding
       #})
% geht dann z.B. so: \tupletweg #13, etc. positive Zahlen schieben die Zahl nach unten, negative nach oben!
       %dasselbe nochmal, hier kann man aber auch auf der x-Achse verschieben
       tupletShift =
       #(define-music-function (parser location shift) (pair?)
       #{
         \once \override TupletBracket #'cross-staff = ##t
         \once \override TupletBracket #'extra-offset = $shift
         \once \override TupletNumber #'extra-offset = $shift
       #})
   %funktioniert z.B. so  \tupletShift #'(x . y )  
   %das ganze jetzt für immer
   TupletShift =
       #(define-music-function (parser location shift) (pair?)
       #{
          \override TupletBracket #'cross-staff = ##t
          \override TupletBracket #'extra-offset = $shift
          \override TupletNumber #'extra-offset = $shift
       #})
        TupletNormal=
       #(define-music-function (parser location shift) (pair?)
       #{
          \override TupletBracket #'cross-staff = ##f
          \revert TupletBracket #'extra-offset 
          \revert TupletNumber #'extra-offset 
       #})
       
%%%%%wenn die xtole zu kurz ist, hilft
       tupletlang =
 #(define-music-function (parser location minimum-length) (number?)
       #{
       \override TupletBracket #'springs-and-rods = #ly:spanner::set-spacing-rods
 \override TupletBracket #'minimum-length = #$minimum-length
       #})
       %geht nach dem Motto: \tupletlang #3; die Funktion definiert die minimale Länge der Klammer
       tupletkurz = {  \revert TupletBracket #'springs-and-rods \revert TupletBracket #'minimum-length }
%%%%%%%%%%%% Manchmal werden die Balken bei Quintolen nicht richtig gesetzt. Dies schafft Abhilfe:
quintolbeam = { \once \set beatLength = #(ly:make-moment 1 20) }
%%%%%%%%% diesen Befehl for \times 4/5 setzen!
% jetzt kommen balkierungen, vielleicht ganz praktisch!

dreierbalken = #(define-music-function (parser location x y z ) (ly:music? ly:music? ly:music?)
#{
	\context Voice <<        $x s1*0 [  >> $y \context Voice <<        $z s1*0 ]  >> 
     #})
     
     viererbalken = #(define-music-function (parser location w x y z ) (ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $w s1*0 [  >> $x  $y \context Voice << $z s1*0 ]  >> 
     #})
     fuenferbalken = #(define-music-function (parser location v w x y z ) (ly:music? ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $v s1*0 [  >> $w $x  $y \context Voice << $z s1*0 ]  >> 
     #})
     
    % ein grafisches symbol:
  pfeilab =    \markup { \fontsize #5 \override #'(thickness . 2) \combine \draw-line #'(0 . 4) \arrow-head #Y #DOWN ##f } 
  
  %Bei Bedarf eine stimme zeigen:
  zeigsmir = {
 \set Staff.keepAliveInterfaces = #'(
    rhythmic-grob-interface
    multi-measure-rest-interface
    lyric-interface
    stanza-number-interface
    percent-repeat-interface)
}
%vielleicht bringt das ja was!
wegdamit = \unset Staff.keepAliveInterfaces
% TextLänge in TimeSig berücksichtigen, oder auch nicht
TimeTextAn = {
  \override TimeSig.TextScript  #'extra-spacing-width = #'(0 . 0)
  \override TimeSig.TextScript  #'extra-spacing-height = #'(-inf.0 . +inf.0)
}

TimeTextAus = {
  \override TimeSig.TextScript  #'extra-spacing-width = #'(+inf.0 . -inf.0)
  \override TimeSig.TextScript  #'extra-spacing-height = #'(0 . 0)
}

%ewig lange Metronomwzeichnungen krigt man in den Griff mit:
metrolangan = {
  \override Score.MetronomeMark  #'extra-spacing-width = #'(0 . 0)
  \override Score.MetronomeMark  #'extra-spacing-height = #'(-inf.0 . +inf.0)
}

metrolangaus = {
  \override Score.MetronomeMark  #'extra-spacing-width = #'(+inf.0 . -inf.0)
  \override Score.MetronomeMark  #'extra-spacing-height = #'(0 . 0)
}
guitarclef = {\set Staff.clefGlyph = #"clefs.G"
  \set Staff.clefPosition = #-2
  \set Staff.clefOctavation = #-7
  \set Staff.middleCPosition = #1 }

  %%% Stichnoten!!
%   stich = {
%     \set fontSize = #-2
%     \override Stem #'length-fraction = #0.8
%     \override Beam #'thickness = #0.384
%     \override Beam #'length-fraction = #0.8
%   }
%   nostich = { \unset fontSize \revert Stem #'length-fraction 
%     \revert Beam #'thickness
  %     \revert Beam #'length-fraction }
  
  
  halslang = 
	#(define-music-function (parser location length) (number?)
     #{
       
   \override Stem #'length = $length
     
   
       #})
%% Funktioniert dann nach dem Motto: \halslang #15 
       halsnormal = { \revert  Stem #'length }
       
       stich = {
         \set fontSize = #-2
         \override Stem #'length-fraction = #0.8
         \override Beam #'thickness = #0.384
         \override Beam #'length-fraction = #0.8
       }
       
       
         nostich = {
           \unset fontSize 
           \revert Stem #'length-fraction 
           \revert Beam #'thickness
           \revert Beam #'length-fraction 
         }
         %%% Vorschlagsnoten
         vorlang = #(define-music-function (parser location x) (ly:music?)
         #{ \appoggiatura     $x  #})
%    funktioniert dann z.B. so:      \relative { c4 d e f \vorlang a g1 } 

         vorkurz = #(define-music-function (parser location x) (ly:music?)
         #{ \acciaccatura     $x  #})
         %       funktioniert dann z.B. so:       \relative { c4 d e f \vorkurz a8 g1 } 
         %%%%%%%% fuer die alte Musik::
         mensurstrich = {  \override Staff.BarLine #'bar-size = #1
           \override Staff.BarLine #'extra-offset = #'(0 . 2) }
           normalstrich = {   \revert Staff.BarLine #'bar-size 
             \revert Staff.BarLine #'extra-offset \override Staff.BarLine #'transparent = ##f
           }
             mensurfueralle = { \override Staff.BarLine #'transparent = ##t }
             
             unsichtbar = { \hideNotes \revert Staff.Tie #'transparent \override Staff.Tie #'transparent = ##t \override Slur #'transparent = ##t 
               \override Staff.Dots               #'transparent = ##t
               \override Staff.Beam               #'transparent = ##t    
	       \override Staff.Rest               #'transparent = ##t
               \override Staff.Accidental         #'transparent = ##t
               \override Staff.Slur               #'transparent = ##t
               \override Staff.PhrasingSlur       #'transparent = ##t
               \override Staff.Hairpin            #'transparent = ##t
               \override Staff.TextScript         #'transparent = ##t
               \override Staff.Script             #'transparent = ##t
               \override Staff.DynamicText        #'transparent = ##t
               \override Staff.NoteHead           #'no-ledgers  = ##t
               \override Staff.TupletBracket #'bracket-visibility = ##f 
               \override Staff.TupletNumber #'stencil = ##f 
             }
             sichtbar = { \unHideNotes  
	       \revert Staff.Tie #'transparent 
	       \override Staff.Tie #'transparent = ##t 
	       \override Staff.Slur #'transparent = ##t 
	        \override Staff.Dots               #'transparent = ##f
                \override Staff.Beam               #'transparent = ##f    
		\override Staff.Rest               #'transparent = ##f
                \override Staff.Accidental         #'transparent = ##f
                \override Staff.Slur               #'transparent = ##f
                \override Staff.PhrasingSlur       #'transparent = ##f
                \override Staff.Hairpin            #'transparent = ##f
                \override Staff.TextScript         #'transparent = ##f
                \override Staff.Script             #'transparent = ##f
                \override Staff.DynamicText        #'transparent = ##f
                \override Staff.NoteHead           #'no-ledgers  = ##f
               \override Staff.TupletBracket #'bracket-visibility = ##t
               \override Staff.TupletNumber #'stencil = ##t
             }
             %%%%%%%Beispiele automatisch nummerieren
             #(define counter-alist '())

             #(define-markup-command (counter layout props name) (string?)
             (let* ((oldval (assoc-ref counter-alist name))
             (newval (if (number? oldval) (+ oldval 1) 1)))
             (set! counter-alist (assoc-set! counter-alist name newval))
             (interpret-markup layout props
             (markup (number->string newval)))))

             #(define-markup-command (setcounter layout props name value) (string? number?)
             (set! counter-alist (assoc-set! counter-alist name (- value 1)))
             (interpret-markup layout props (make-counter-markup name)))
%              music = \relative { c4 d e f g1 }
%              \markup {Beispiel \counter #"zahl":  }
%              \new Staff { \music }
             %das ganze funktionert dann nach dam Motto:
             %   \markup {Beispiel \counter #"zahl":  }
             %   \new Staff { \transpose c f {\music } }
             %   \markup { Beispiel \counter #"neuerzaehler":}
             %   %jetzt wird wieder von vorne angefangen!
             %   \new Staff { \music }


             %%%%%%%%%% STICHNOTEN!!!!!!!!!!!
             
             % set the cue instrument name
             setCue = #(define-music-function (parser location instr) (string?)
             #{ \set Voice.instrumentCueName = $instr #} )

             % generate a cue music section with instrument names
             % Parameters: \namedCueDuring NameOfQuote CueDirection CueInstrument OriginalInstrument music
             %                 -) NameOfQuote CueDirection music are the parameters for \cueDuring
             %                 -) CueInstrument and OriginalInstrument are the displayed instrument names
             % typical call:
             % \namedCueDuring #"vIQuote" #UP #"V.I" #"Sop." { R1*3 }
             %      This adds the notes from vIQuote (defined via \addQuote) to three measures, prints "V.I" at
             %      the beginning of the cue notes and "Sop." at the end
             namedCueDuring = #(define-music-function (parser location cuevoice direction instrcue instr cuemusic) (string? number? string? string? ly:music?)
             #{
               \tag #'cued { \cueDuring #$cuevoice #$direction { \setCue #$instrcue $cuemusic \setCue #$instr } }
               \tag #'uncued $cuemusic
             #}
             )
%das wird dann so aufgerufen:
% \namedCueDuring #"Quotename" #1 der #2 für Stimme #"InsrumentdesStichs" #"Instrumentdanach" { R1*2 }

             % set the cue instrument name and clef
             setClefCue = #(define-music-function (parser location instr clef) 
             (string? string?)
             #{
               \once \override Staff.Clef #'font-size = #-3 \clef $clef
               \set Voice.instrumentCueName = $instr
             #} )

             % generate a cue music section with instrument names and clef changes
             % Parameters: \cleffedCueDuring NameOfQuote CueDirection CueInstrument CueClef OriginalInstrument OriginalClef music
             %                 -) NameOfQuote CueDirection music are the parameters for \cueDuring
             %                 -) CueInstrument and OriginalInstrument are the displayed instrument names
             %                 -) CueClef and OriginalClef are the clefs for the the cue notes and the clef of the containing voice
             % typical call:
             % \cleffedCueDuring #"vIQuote" #UP #"V.I" #"treble" #"Basso" #"bass" { R1*3 }
             %      This adds the notes from vIQuote (defined via \addQuote) to three measures, prints "V.I" at
             %      the beginning of the cue notes and "Basso" at the end. The clef is changed to treble at the 
             %      beginning of the cue notes and reset to bass at the end
             cleffedCueDuring = #(define-music-function (parser location cuevoice direction instrcue clefcue instr clefinstr cuemusic) 
             (string? number? string? string? string? string? ly:music?)
             #{
               \tag #'cued { \cueDuring #$cuevoice #$direction { \setClefCue #$instrcue #$clefcue $cuemusic \setClefCue #$instr #$clefinstr } }
               \tag #'uncued $cuemusic
             #}
             )
             %%%%damit das ganze funktioniert steht hinterher in der Partitur \keepWithTag #'uncued, in der Stimme \keepWithTag #'cued
       
	     %Featherbeams!
	     featherrechts = #(define-music-function (parser location x) (ly:music?)
     #{
	\override Beam #'grow-direction = #RIGHT \featherDurations #(ly:make-moment 1 3)     $x \revert Beam #'grow-direction 
     #})
     featherlinks = #(define-music-function (parser location x) (ly:music?)
     #{
	\override Beam #'grow-direction = #LEFT \featherDurations #(ly:make-moment 1 3)     $x \revert Beam #'grow-direction 
     #})
     %%balken setzen
     zweierbalken = #(define-music-function (parser location x y ) (ly:music? ly:music?)
#{
	\context Voice <<        $x s1*0 [  >> \context Voice <<        $y s1*0 ]  >> 
     #}) 
dreierbalken = #(define-music-function (parser location x y z ) (ly:music? ly:music? ly:music?)
#{
	\context Voice <<        $x s1*0 [  >> $y \context Voice <<        $z s1*0 ]  >> 
     #})
     
     viererbalken = #(define-music-function (parser location w x y z ) (ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $w s1*0 [  >> $x  $y \context Voice << $z s1*0 ]  >> 
     #})
     fuenferbalken = #(define-music-function (parser location v w x y z ) (ly:music? ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $v s1*0 [  >> $w $x  $y \context Voice << $z s1*0 ]  >> 
     #})
     
     
     %bögen setzen
     
     zweierbogen = #(define-music-function (parser location x y ) (ly:music? ly:music?)
#{
	\context Voice <<        $x s1*0 (  >> \context Voice <<        $y s1*0 )  >> 
     #}) 
dreierbogen = #(define-music-function (parser location x y z ) (ly:music? ly:music? ly:music?)
#{
	\context Voice <<        $x s1*0 (  >> $y \context Voice <<        $z s1*0 )  >> 
     #})
     
     viererbogen = #(define-music-function (parser location w x y z ) (ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $w s1*0 (  >> $x  $y \context Voice << $z s1*0 )  >> 
     #})
     fuenferbogen = #(define-music-function (parser location v w x y z ) (ly:music? ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $v s1*0 (  >> $w $x  $y \context Voice << $z s1*0 )  >> 
     #})
       achterbogen = #(define-music-function (parser location s t u v w x y z ) (ly:music? ly:music? ly:music? ly:music? ly:music? ly:music? ly:music? ly:music? )
#{
	\context Voice <<        $s s1*0 (  >> $t $u $v $w $x  $y \context Voice << $z s1*0 )  >> 
     #})
     %% in einen Kontextschicken
     einstimmig = #(define-music-function (parser location x y ) (ly:music? ly:music?)
#{
	\context Voice <<  $x  $y  >>  
     #}) 
     %zweistimmig
     zweistimmig = #(define-music-function (parser location x y ) (ly:music? ly:music?)
#{
	 <<  $x \\  $y  >>  
     #}) 
     %berechnen
     kOn= { \set Score.skipTypesetting = ##f } %ein Bereich wird berechnet
kOff = { \set Score.skipTypesetting = ##t } %wird nicht berechnet!
 berechne = #(define-music-function (parser location x) (ly:music?)
     #{ %hier irgendeinen Lilypondcode eingeben, z.B.:
	    \kOn $x \kOff
     #})
     ta = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<     $x  { s1 *0 -\tweak \once 
            \override Script #'extra-offset = #'(6.2 . -5.6) -- -> } >>
     #})
%ta meint: tenutoakzent, bei dem das Tenuto näher an der Note ist, als der Akzent!
     
%%% jetzt kommt was tolles, mit dem man Kollistionen verhindern kann!
    
%% In 2.13.0 and earlier, the following
%% warning may be triggered multiple times:
%%   warning: Ignoring grob for slur: <grob>. avoid-slur not set?
%% This issue has been resolved in 2.13.1

#(define (parse-grob-sym grob-sym)
   (let* ((grob-str  (symbol->string grob-sym))
          (dot-index (string-index grob-str #\.))
          (context   (if dot-index
                         (string-take grob-str dot-index)
                         "Voice"))
          (grob      (if dot-index
                         (substring grob-str (+ dot-index 1))
                         grob-str)))
     (cons context grob)))
       
hideCurvesFrom =
#(define-music-function
   (parser location grob-sym x-padding y-padding)
   (symbol? pair? pair?)
   (let* ((context  (car (parse-grob-sym grob-sym)))
          (top-grob (cdr (parse-grob-sym grob-sym))))
#{
  \override Tie #'layer = #-2
  \override Slur #'layer = #-2
  \override PhrasingSlur #'layer = #-2
  
  \override $context . $top-grob #'avoid-slur = #'ignore
  \override $context . $top-grob #'layer = #-1
  \override $context . $top-grob #'stencil =
    #(lambda (grob)
       (define (get-stil-proc alist)
         ;; removes the first 'stencil entry from the grob-property
         ;; alist, implicitly created by this callback:
         ;;   (stencil . #<procedure #f (grob)>)
         ;; and then retrieves the original 'stencil procedure.
         (let ((stil-proc (ly:assoc-get 'stencil alist)))
           (if (procedure-name stil-proc)
               stil-proc
               (begin (set! alist (assoc-remove! alist 'stencil))
                      (get-stil-proc alist)))))
       (let* ((basic-props (ly:grob-basic-properties grob))
              (stil-proc (get-stil-proc basic-props))
              (this-stil (stil-proc grob))
              (stil-x-ext (ly:stencil-extent this-stil 0))
              (stil-y-ext (ly:stencil-extent this-stil 1))
              (box-x-ext (cons (- (car stil-x-ext) (car $x-padding))
                               (+ (cdr stil-x-ext) (cdr $x-padding))))
              (box-y-ext (cons (- (car stil-y-ext) (car $y-padding))
                               (+ (cdr stil-y-ext) (cdr $y-padding))))
              (box-w (- (cdr box-x-ext) (car box-x-ext)))
              (box-h (- (cdr box-y-ext) (car box-y-ext))))
      (ly:stencil-add
       (ly:make-stencil
        (list 'embedded-ps
         (ly:format
          (string-append "gsave\n"
                         "currentpoint translate\n"
                         "1 setgray\n"
                         "~4f ~4f ~4f ~4f rectfill\n"
                         "grestore\n")
          (car box-x-ext)
          (car box-y-ext)
          box-w
          box-h))
        stil-x-ext
        stil-y-ext)
       this-stil)))
#}))

revertHideCurvesFrom =
#(define-music-function
   (parser location grob-sym)
   (symbol?)
   (let* ((context  (car (parse-grob-sym grob-sym)))
          (top-grob (cdr (parse-grob-sym grob-sym))))
#{
  \revert Tie #'layer
  \revert Slur #'layer
  \revert PhrasingSlur #'layer
  \revert $context . $top-grob #'avoid-slur
  \revert $context . $top-grob #'layer
  \revert $context . $top-grob #'stencil
#}))

%%%%%%%%%%%%%%%%%% EXAMPLE %%%%%%%%%%%%%%%%%%
%{

\relative {
  \repeat volta 2 {
    
    %% syntax: \hideCurvesFrom [grob] [x-padding] [y-padding]
        
    % always call \hideCurvesFrom before the curve starts:
    \hideCurvesFrom #'Fingering           #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.KeySignature  #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.TimeSignature #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.Accidental  #'(0.3 . 0.003) #'(0 . 0)
    % a negative padding value can prevent whiteout near an edge:
    \hideCurvesFrom #'Staff.Clef          #'(0.3 . 0.3) #'(0 . -0.5)
    
    \clef bass
      \once \override TextScript #'extra-offset = #'(-8 . 0)
      e,2.\(^\markup \fontsize #-1 \italic
               {tacet la \concat {1 \super \lower #0.5 ma} volta:}
      d4( |
    
    \clef treble \key g \major
      c''4)^2 c2 b4~ |
    
    \time 3/4
      b2\) 
      % updating a previously entered command:
      \hideCurvesFrom #'Staff.Clef #'(0.3 . 0.3) #'(0 . 0)
      fis4( |
    
    \clef bass \time 2/4
      d,4)
      % always call \hideCurvesFrom before the curve starts:
      \hideCurvesFrom #'Score.VoltaBracket #'(0.3 . 0.8) #'(3 . 0)
      e4( |
  }
  
  \alternative {
    { r2 | }
    {
      % revert commands independently as needed:
      \revertHideCurvesFrom #'Score.VoltaBracket
      d2)
    }
  }
    % revert commands when no longer needed:
    \revertHideCurvesFrom #'Fingering
    \revertHideCurvesFrom #'Staff.Clef
    \revertHideCurvesFrom #'Staff.KeySignature
    \revertHideCurvesFrom #'Staff.TimeSignature
}%}
Kurvenunterbrech = {
    \hideCurvesFrom #'Fingering           #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.KeySignature  #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.TimeSignature #'(0.3 . 0.3) #'(0 . 0)
    \hideCurvesFrom #'Staff.Accidental  #'(0.3 . 0.003) #'(0 . 0) 
}
% jetzt kommt was zum Zitate einfügen
#(use-modules (srfi srfi-39))

#(define *current-moment* (make-parameter (ly:make-moment 0 1 0 1)))

#(define moment-null (ly:make-moment 0 1 0 1))

#(define (music-has-no-length? music)
  "Is music empty of notes, rests or skips?"
  (equal? (ly:music-length music) moment-null))

#(define (simultaneous? music)
  (memq (ly:music-property music 'name)
    (list 'SimultaneousMusic 'EventChord)))

#(define (defined-music? music)
  (not (eq? 'Music (ly:music-property music 'name))))

#(define (chord-event? music)
  (eq? 'EventChord (ly:music-property music 'name)))

#(define (get-duration music)
  (ly:music-property music 'duration))

#(define (moment>=? momentA momentB)
  (not (ly:moment<? momentA momentB)))

#(define (moment-inside? moment from-moment to-moment)
  (and
    (moment>=? moment from-moment)
    (ly:moment<? moment to-moment)))

#(define (whole-music-inside? begin-music end-music left-range right-range)
  (and
    (moment>=? begin-music left-range)
    (moment>=? right-range end-music )
    (not (equal? begin-music right-range))))

#(define (whole-music-outside? begin-music end-music left-range right-range)
  (or
    (moment>=? left-range end-music)
    (moment>=? begin-music right-range)))

#(define (moment->duration moment)
  ;see duration.cc in Lilypond sources (Duration::Duration)
  (let* ((p (ly:moment-main-numerator moment))
         (q (ly:moment-main-denominator moment))
         (k (- (ly:intlog2 q) (ly:intlog2 p)))
         (dots 0))
   ;(ash p k) = p * 2^k
   (if (< (ash p k) q) (set! k (1+ k)))
   (set! p (- (ash p k) q))
   (while (begin (set! p (ash p 1))(>= p q))
    (set! p (- p q))
    (set! dots (1+ dots)))
   (if (> k 6)
    (ly:make-duration 6 0)
    (ly:make-duration k dots))
))

#(define (extract-music music from to)
  "Keeps only music between `from' and `to', `from' and `to' as moment"
  (let ((begin-pos (*current-moment*))
        (end-pos (ly:moment-add
                   (*current-moment*)
                   (ly:music-length music))))
   (cond
    ((whole-music-inside? begin-pos end-pos from to)
      (*current-moment* end-pos)
      music)
    ((whole-music-outside? begin-pos end-pos from to)
      (*current-moment* end-pos)
      (make-music 'Music))
    ; the intervals [begin-pos end-pos] [from to] overlap
    (else
    (cond
    ; inside a chords or for multiRest events
    ((ly:duration? (get-duration music))
      (if (moment-inside? begin-pos from to)
        (set! end-pos to)
        (begin
          (set! begin-pos from)
          (if (not (moment-inside? end-pos from to))(set! end-pos to))))
      (ly:music-set-property! music 'duration 
          (moment->duration  (ly:moment-sub end-pos begin-pos)))
      (*current-moment* end-pos)
      music)
    (else     ; for containers of chords
      (let ((elts (ly:music-property music 'elements))
          (elt  (ly:music-property music 'element)))
        (if (ly:music? elt)
        (ly:music-set-property! music 'element (extract-music elt from to)))
        (if (pair? elts) 
        (cond  
          ((simultaneous? music)    ; simultaneous music OR EventChords
          (ly:music-set-property! music 'elements (filter
            (lambda (evt)
              (or (music-has-no-length? evt) ; i.e for 'VoiceSeparator
                (begin
                  (*current-moment* begin-pos)  ; restore *current-moment*
                  (set! evt (extract-music evt from to))
                  (defined-music? evt)))) ; keeps if not (make-music 'Music)
            elts))
          (*current-moment* end-pos))
         (else              ; sequential music
          (ly:music-set-property! music 'elements (filter
            (lambda (evt)
              (set! evt (extract-music evt from to))
              (defined-music? evt))
            elts)))))
        music)))))))

%%%%%%%%%%%%%%%%%%%%%% the main function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
extractMusic =
#(define-music-function (parser location music from during) (ly:music? ly:music? ly:music?)
  (let* ((from-length (ly:music-length from))
         (during-length (ly:music-length during))
         (to-length (ly:moment-add during-length from-length)))
    (parameterize ((*current-moment* (ly:make-moment 0 1 0 1)))
                  (extract-music music from-length to-length))))
#(define zitiersmir extractMusic)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%funktioniert nach dem Motto:
% \zitiersmir \oben s1*2 s2
%die Angabe \oben sagt, wer zitiert wird, s1*2 sagt, an welcher Stelle die Variable "oben" zitiert werden soll, s1 sagt, wie langt das Zitat dauern soll
  
  
 
