\version "2.12.0"
%gebrochene Quinten
quintrauf = #(define-music-function (parser location x) (ly:music?)
     #{
	     $x \transpose c g { $x }
     #})
     
     % parallele kleine Terzen
     kleineterz = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c es { $x } >> 
     #})
    
     %%%%%%% Parallele OKTAVEN!!!!!!!!!!!!!!!!!
    okt = #(define-music-function (parser location x) (ly:music?)
                                 
     #{
	\context Voice <<        $x \transpose c c' { $x } >> 
     #})
     %große Sekund
     sk = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c d { $x } >> 
     #})
     %quarte, rein natürlich
    quart = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c f  { $x } >> 
     #})
     %kleine Septe
     ksp =  #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c bes { $x } >> 
     #})
     %große None 
      gnon = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c d' { $x } >> 
     #})
     %%%%%% Gebrochene Oktaven %%%%%%%%%%%%%%%
     #(define (make-sequential-music elements)
 (make-music
   'SequentialMusic
   'elements
   elements))

#(define (make-music-note pitch duration)
 (make-music
   'NoteEvent
   'pitch pitch
   'duration duration))

#(define (make-music-chord elements)
 (make-music
   'EventChord
   'elements elements))

#(define (broken-octaves muslist arg first?)
 (if (null? muslist) '()
 (let* ((notes (ly:music-property (car muslist) 'elements))Alle Dateien
         (pitch (ly:music-property (car notes) 'pitch))
         (first-pitch
           (if first?
             pitch
             (ly:make-pitch
               (+ (- arg) (ly:pitch-octave pitch))
               (ly:pitch-notename pitch)
               (ly:pitch-alteration pitch))))
         (second-pitch (ly:make-pitch (1- arg) (ly:pitch-notename
pitch) (ly:pitch-alteration pitch)))
         (duration (ly:music-property (car notes) 'duration))
         (first-chord
           (make-music-chord
             (cons (make-music-note first-pitch duration) (cdr notes))))
         (second-chord
           (make-music-chord
             (cons (make-music-note second-pitch duration)
(ly:music-deep-copy (cdr notes))))))
     (cons first-chord (cons second-chord (broken-octaves (cdr
muslist) arg #f))))))

brokenoctaves = #(define-music-function (parser location arg mus)
(integer? ly:music?)
 (make-sequential-music (broken-octaves (ly:music-property mus
'elements) arg #t)))
%%%%%%%%%%%%%%% Achtung: diese Funktion funktioniert nur innerhalb einer \relative Klammer!
%% Also z.B. so: 
%% \new Staff { c' 8 c' g' g' a' a' g' 4 \relative c' { \brokenoctaves #1 { c 16 c g' g a a g8  } } }
%% Funktioniert nicht mit Tuplets
%%%%%%%%%%%%%%%%%%%%%%%% Akkorde %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Sextakkord, Dur
 sextak = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c es { $x } \transpose c aes { $x } >> 
     #})
%Moll sextakkord
msextak = #(define-music-function (parser location x) (ly:music?)
     #{
	\context Voice <<        $x \transpose c e { $x } \transpose c a { $x } >> 
     #})

     %%Auch diatonische Transpositionen sind möglich:

#(define (true-quotient n d)
 "Return the true quotient in integer division of n by d, i.e.
return the integer q so that there is a unique integer r that
satisfies  n = qd + r  and  0 <= r < |d|"
 (if (>= n 0)
  (quotient n d)
  (- (quotient n d) 1)))

#(define (ly-pitch->modal-pitch ly-pitch scale tonic-c-diff)
 "Convert ly-pitch to a list (octave degree depresentation) which represents
the modal pitch in scale, with tonic-c-diff as the pitch diff from tonic to
middle C.  scale should be a notename->alteration alist of length 7 which
represents the alteration of each note with C as first pitch of the scale."
 (let* ((normalized-pitch (ly:pitch-transpose ly-pitch tonic-c-diff))
        (notename (ly:pitch-notename normalized-pitch)))
  (list
   (ly:pitch-octave normalized-pitch) ;; octave
   notename ;; degree
   ;; alteration
   (- (ly:pitch-alteration normalized-pitch) (ly:assoc-get notename scale 0)))))

#(define (degree-transpose modal-pitch modal-pitch-delta scale-length)
"Transpose modal-pitch (octave degree alteration) by modal-pitch-delta assuming
scale-length."
 (let* ((octave (car modal-pitch))
        (degree (cadr modal-pitch))
        (alteration (caddr modal-pitch))
        (octave-delta (car modal-pitch-delta))
        (degree-delta (cadr modal-pitch-delta))
        (alteration-delta (caddr modal-pitch-delta))
        (relative-new-degree (+ degree degree-delta)))
  (list
   (+
    octave
    octave-delta
    (true-quotient relative-new-degree scale-length))
   (modulo relative-new-degree scale-length)
   (+ alteration alteration-delta))))

#(define (modal-pitch->ly-pitch modal-pitch scale c-tonic-diff)
 "Convert modal-pitch -- a list (octave degree alteration) -- to a
standard pitch using scale and pitch diff from middle C to tonic.
scale should be a notename->alteration alist of length 7 which represents
the alteration of each note with C as first pitch of the scale."
 (let* ((octave (car modal-pitch))
        (degree (min 6 (cadr modal-pitch)))
        (alteration (caddr modal-pitch))
        (abs-alteration (+ alteration (ly:assoc-get degree scale 0))))
  (ly:pitch-transpose
   (ly:make-pitch octave degree abs-alteration)
   c-tonic-diff)))

#(define (lookup-music-property event type)
 "Return the first music property of the given type found in event,
or #f is no such property is found.  event should be music or a list
of music."
 (if (null? event)
  #f
  (if (list? event)
   (or
    (lookup-music-property (car event) type)
    (lookup-music-property (cdr event) type))
   (let ((p (ly:music-property event 'pitch)))
    (if (not (null? p))
     p
     (let* ((e (ly:music-property event 'element))
            (es (ly:music-property event 'elements))
            (p2 (if (null? e)
                 '()
                 (lookup-music-property e type))))
      (if (not (null? p2))
       p2
       (lookup-music-property es type))))))))

#(define (mode-transpose
         pitch-note1 pitch-note2 tonic-note1 scale1 tonic-note2 scale2 music)
 (let* ((tonic-diff1 (ly:pitch-diff
                      (ly:make-pitch 0 0 0)
                      (lookup-music-property tonic-note1 'pitch)))
        (tonic-diff2 (ly:pitch-diff
                      (lookup-music-property tonic-note2 'pitch)
                      (ly:make-pitch 0 0 0)))
        (modal-pitch-delta (map
                            -
                            (ly-pitch->modal-pitch
                             (lookup-music-property pitch-note2 'pitch)
                             scale2
                             (ly:pitch-negate tonic-diff2))
                            (ly-pitch->modal-pitch
                             (lookup-music-property pitch-note1 'pitch)
                             scale1
                             tonic-diff1))))
  (music-map
   (lambda (event)
    (let ((p (ly:music-property event 'pitch)))
     (if (ly:pitch? p)
      (ly:music-set-property!
       event
       'pitch
       (modal-pitch->ly-pitch
        (degree-transpose
         (ly-pitch->modal-pitch p scale1 tonic-diff1)
         modal-pitch-delta
         7)
        scale2
        tonic-diff2)))
     event))
   music)))

modeTranspose =
#(define-music-function
 (parser location pitch-note1 pitch-note2 tonic-note1 scale1 tonic-note2 scale2 music)
 (ly:music? ly:music? ly:music? list? ly:music? list? ly:music?)
 "Transpose music diatonicly by the interval between pitch-note1
and pitch-note2, interpreting pitches in scale1 on tonic-note1
and producing pitches in scale2 on tonic-note2."
 (mode-transpose
  pitch-note1 pitch-note2 tonic-note1 scale1 tonic-note2 scale2 music))

diatonicTranspose =
#(define-music-function
 (parser location pitch-note1 pitch-note2 tonic-note scale music)
 (ly:music? ly:music? ly:music? list? ly:music?)
 "Transpose music diatonicly by from pitch-note1 to pitch-note2
in scale on tonic-note."
 (mode-transpose
  pitch-note1 pitch-note2 tonic-note scale tonic-note scale music))
%das ganze kann dann so gunktioniern:
% pattern = \relative c' { c2~ c8 d16 e f g a b c4 g e c }
% 
% \new Staff {
%  \pattern
%  \diatonicTranspose c d c \major \pattern % I -> II
%  \diatonicTranspose c e c \major \pattern % I -> III
% }
%man kanm auch von dem einen in den anderen Modus transponieren
% mixing lydian and mixolydian modes
% milydian = #`(
%  (0 . 0)
%  (1 . 0)
%  (2 . 0)
%  (3 . ,SHARP)
%  (4 . 0)
%  (5 . 0)
%  (6 . ,FLAT))
% 
% melodie = \relative c' { \times 2/3 { cis8 d e } f2 }
% 
% \new Staff {
%  \time 3/4
%  \melodie
%  \modeTranspose cis d g \milydian d \lydian \melodie
%  \modeTranspose cis dis' g \milydian e \lydian \melodie
% }
  #(define (lookup-context-property c symbol)
  (if (ly:context? c)
  (let ((v (ly:context-property c symbol)))
  (if (and v (not (null? v)))
  v
  (lookup-context-property (ly:context-parent c) symbol)))
  #f))


  keyDiatonicTranspose =
  #(define-music-function
  (parser location pitch-note1 pitch-note2 music)
  (ly:music? ly:music? ly:music?)
  "Transpose music diatonicly by from pitch-note1 to pitch-note2
  in scale on tonic-note."
  (make-music 'ApplyContext
  'origin location
  'procedure (
  lambda (c)
  (let ((k (lookup-context-property c 'keySignature)))
  (ly:interpret-music-expression
  (make-music
  'ContextSpeccedMusic
  'property-operations
  '()
  'context-id
  (ly:context-id c)
  'context-type
  (ly:context-name c)
  'element
  (mode-transpose
  pitch-note1 pitch-note2 #{ c #} k #{ c #} k music))
  (ly:context-find c 'Global))))))
  
  %erkennt automatisch die Tonart, also, z.B.:
%   minorPattern = {
%     c'2 ~  c'8 d'16 ees' f' g' aes' bes' c''4 g' ees' c'
%   }
% 
%   {
%     \key c \minor
%     \repeat unfold 2 c'1
%     \keyDiatonicTranspose c d \minorPattern
%   }
  
  %transponieren, ohne Doppelkreuze und son Mist
#(define  (naturalize-pitch p)
  (let* ((o (ly:pitch-octave p))
         (a (* 4 (ly:pitch-alteration p)))
    ; alteration, a, in quarter tone steps, for historical reasons
         (n (ly:pitch-notename p)))
    (cond
     ((and (> a 1) (or (eq? n 6) (eq? n 2)))
      (set! a (- a 2))
      (set! n (+ n 1)))
     ((and (< a -1) (or (eq? n 0) (eq? n 3)))
      (set! a (+ a 2))
      (set! n (- n 1))))
    (cond
     ((> a 2) (set! a (- a 4)) (set! n (+ n 1)))
     ((< a -2) (set! a (+ a 4)) (set! n (- n 1))))
    (if (< n 0) (begin (set! o (- o 1)) (set! n (+ n 7))))
    (if (> n 6) (begin (set! o (+ o 1)) (set! n (- n 7))))
    (ly:make-pitch o n (/ a 4))))

#(define (naturalize music)
  (let* ((es (ly:music-property music 'elements))
         (e (ly:music-property music 'element))
         (p (ly:music-property music 'pitch)))
    (if (pair? es)
        (ly:music-set-property!
         music 'elements
         (map (lambda (x) (naturalize x)) es)))
    (if (ly:music? e)
        (ly:music-set-property!
         music 'element
         (naturalize e)))
    (if (ly:pitch? p)
        (begin
          (set! p (naturalize-pitch p))
          (ly:music-set-property! music 'pitch p)))
    music))

naturalizeMusic =
#(define-music-function (parser location m)
					(ly:music?)
			(naturalize m))
#(define vereinfachs naturalizeMusic)  
%Enharmonische Verwechslung
%Nur Kreuze zeigen
kreuze = #(define-music-function (parser location x) (ly:music?)
     #{
	      \transpose  ges fis  $x 
     #})
%nur Bes zeigen
bees = #(define-music-function (parser location x) (ly:music?)
     #{
	      \transpose  fis ges  $x 
     #})
meistkreuze = #(define-music-function (parser location x) (ly:music?)
     #{
	  \vereinfachs  \transpose  ges fis  $x 
     #})
meistbees = #(define-music-function (parser location x) (ly:music?)
     #{
	  \vereinfachs  \transpose  fis ges  $x 
     #})

%Akkorde
%Zwei bis fünf Töne gleichzeitig 
 zweiklang = #(define-music-function (parser location x y ) (ly:music? ly:music? )
     #{
        \context Voice <<        $x  $y  >> 
     #})
  dreiklang = #(define-music-function (parser location x y z) (ly:music? ly:music? ly:music? )
     #{
        \context Voice <<        $x  $y $z  >> 
     #})
   vierklang = #(define-music-function (parser location w x y z) (ly:music? ly:music? ly:music? ly:music?)
     #{
        \context Voice <<       $w  $x  $y $z  >> 
     #})
   
   fuenfklang = #(define-music-function (parser location v w x y z) (ly:music? ly:music?  ly:music? ly:music? ly:music?)
     #{
        \context Voice <<      $v $w  $x  $y $z  >> 
     #})
 
 