\version "2.13.0"

% der Rhythmus des Anfangs
rhRechtsA = #(define-music-function (parser location music) (ly:music?) #{  \makeRhythm $music "2 8 16 16"  #}) 
rhLinksA = #(define-music-function (parser location music) (ly:music?) #{  \makeRhythm $music "8 8 8 4."  #}) %zwischen die Anführungszeichen die Definition eingeben, und vergiss nicht, dem Kind einen Namen zu geben!
\motiv #'tegetegetuu { c'16 ( d' e' f'~ f'2 ) } %das Motiv von Takt drei
taatege = #(define-music-function (parser location music) (ly:music?) #{  \makeRhythm $music "4. 16 16"  #}) 
%%%%%% Bögen, die oft vorkkommen
%rechtsbogenA
rbA = { s2 ( ~ s8 s16 s) }
%linksbogen des Anfangs
lbA = { s8([ s] s8 s4.) }

toeneritoArechts = {  
  \rhRechtsA { cis'' cis'' c'' bes'  a' a' b' c'' }
  \tegetegetuu { cis'' b' bes' a' } % Töne rechts, Takt  1-3
  \rhRechtsA { cis'' cis'' c'' bes'  a' a' b' c'' }
  cis'' 2 cis'' 16 c'' bes' a' | a' 2 | % Töne rechts, Takt 6-7
  \taatege { cis'' c'' b' d'' b' bes' } \tegetegetuu { cis'' c'' b' d'' }
  \tempo "poco più lento"
  \time 2/4 
  \taatege { cis'' c'' b' }
  \fuenfachteldreizwo
  d'' 4. d'' 16 c'' b' bes' 
  \time 2/4 
  cis'' 8. c'' 16 \times 2/3 {b'8 d'' es'' ~ }
  \tempo "a tempo"
  \time 3/4 
  \rhRechtsA { es'' es'' d'' c'' b' b'  cis'' d'' } \meistbees { \tegetegetuu {es'' cis'' c'' b'  }  }
  \rhRechtsA { es'' es'' d'' c'' b' b'  cis'' d'' } \tegetegetuu { es'' d'' cis'' e''  }
  \rhRechtsA { f'' f'' es'' d'' } e'' 16 \bees cis'' c'' fis'' ~ fis'' 2 ~ 
  \time 2/4 
  fis'' 8 f'' 4 es'' 16 d'' 
} %ende toeneritoArechts

boegenritoArechts = {  \repeat "unfold" 2 { \rbA } s2. % Bögen rechts, Takt 1-3 
  \repeat "unfold" 2 { \rbA } s16*11 ~ ( s 16 ~ | s2 ) | % Bögen rechts, Takt 4-7
  \repeat "unfold" 2 { s16*7 ( s16) } s2.
  s16*7 ( s16) | s4. ~ ( s16*3 s16 ) | s4( s8*2/3 s ) s (|
  s2 ~ s8. s16 )  \rbA s2. | \repeat "unfold" 2 { \rbA } s2.\rbA s2. ( s8 ) s4( s16 s )
}
anfangstakte = { \time 3/4 s2.*6 %1-6
              \time 2/4 
              s2*3 %7-9
              \time 3/4 
              s2.
                  }
%%%%%%% links    
  toeneritoAlinks = {
    \meistkreuze { \rhLinksA { cis' es' a g' es' cis' g' a cis' g' a es' % Töne links, Takt  links 1-3
        cis' es' a g' es' cis' g' a g' cis' es' a } % Töne links, Takt 4-6
      es' 8 a c' fis' | 
      \AVP { cis' g' gis d' } \rhLinksA { cis' g' gis d' } % Töne links, Takt 8-10
      cis' 8 g' 4. | gis 8 d' 2 | } % Töne links, Takt keine kreuze mehr
   cis' 8 g f' bes 
   \rhLinksA { a f' es' a' | b a' es' f' | a a' b f' | 
     a f' es' a' | b a' es' f' | a g' bes e' | b gis' c' f' | bes a' cis' fis' |}
   b 8 f' 4. 
  } %ende toeneritoAlinks
  
  boegenritoAlinks = { \repeat "unfold" 6 { \lbA} 
    s4. ( s8 ) | \repeat "unfold" 2 { s8 ( s4.)} s8 ( s) s( s4.) | % Bögen links, Takt 7-10
    s8 ( s4.) | s8 ( s2) | s4.( s8) | % Bögen links, Takt 11-13
    \repeat "unfold" 8 { \lbA } s8 ( s4.) 
  } %ende boegenritoAlinks
  


ritoArechts = { \context Voice << {\toeneritoArechts } { \boegenritoArechts } { \anfangstakte} >> }
ritoAlinks = { \context Voice << {\toeneritoAlinks } { \boegenritoAlinks }>> }

dynaritoA = {
  s8 s8*5 \pdolce 
s2.*5 | s2*3 | s2. |
s2 -\piup | s8*5 | s4\< \scaleDurations #'(2 . 3) {s4 s8\p } | % Dynamik, Takt ende der ersten Seite des Manuskripts
s2.*8 | s2*2 |% Dynamik, Takt 14-23
s2.*2 | s4. \< s8*5 \p | % Dynamik, Takt 14-26
s1 | s4 \scaleDurations #'(4 . 5) {  \dcr s16 \> s4  } s4 s4*2/3 s8*2/3  % Dynamik, Takt 27-28

}
pedritoA = {
s2. \sustainOn s2. \sustainOff \sustainOn s4 \sustainOff \sustainOn s2 \sustainOff \sustainOn
\repeat "unfold" 3 { s2. \sustainOff \sustainOn } % Pedal, Takt 4-6
\repeat "unfold" 2 {s4 \sustainOff \sustainOn } \repeat "unfold" 2 { s2 \sustainOff \sustainOn} s4 \sustainOff \sustainOn s2 \sustainOff  \sustainOn % Pedal, Takt 7- 10
s2 \sustainOff \sustainOn s8*5 \sustainOff \sustainOn
\repeat "unfold" 2 {s4 \sustainOff \sustainOn  }
\repeat "unfold" 2 { \repeat "unfold" 2 { s2. \sustainOff \sustainOn } s4 \sustainOff \sustainOn s2 \sustainOff \sustainOn} % Pedal, Takt 14-19
s2. \sustainOff \sustainOn | % Pedal, Takt 20
s4 s2 \sustainOff \sustainOn | % Pedal, Takt 21
s8  \sustainOff s4. \sustainOn | % Pedal, Takt 22
s4 \sustainOff \sustainOn s4 \sustainOff \sustainOn  | % Pedal, Takt 23
s2 \sustainOff \sustainOn s4 \sustainOff \sustainOn | % Pedal, Takt 24
s4 \sustainOff \sustainOn s4.\sustainOff \sustainOn s8 \sustainOff | % Pedal, Takt 25
s4 \sustainOn s4 \sustainOff \sustainOn s2 \sustainOff | % Pedal, Takt 26
s4 \sustainOn s4 \sustainOff \sustainOn  s4 \sustainOff s8*2/3 s4*2/3 \sustainOn | % Pedal, Takt 27
s4. \sustainOff \sustainOn s8*5 \sustainOff | % Pedal, Takt 28

}