\version "2.13.0"

%der Titel
\header { title = "Xenophonie 4" subtitle = "für mikrotonales Keyboard" composer ="Stefan Thomas (2009)" } 

\include "../../../lilyponds/vorlagen/rhythmen.ly"
\include "../../../lilyponds/vorlagen/dirigiertaktarten.ly"
\include "../../../lilyponds/vorlagen/intervalle.ly"
\include "../../../lilyponds/vorlagen/dynamik.ly"
\include "../../../lilyponds/vorlagen/klavierstyle.ly"
ta = #(define-music-function (parser location x) (ly:music?)
     #{
        \context Voice <<     $x  { s1 *0 -- -> } >>
     #})
% ta = { }
%%%%%%%%% jetzt die einzelnen Abschnitte, die die Musik enthalten:
  \include "ritornelle.ly"
  \include "coupletA.ly"
    \include "coupletAweiter.ly"
%
 
 %und jetzt das ganze:
rechts = { \kreuzAn \tempo 4=63
  \set PianoStaff.instrumentName = "Synthesizer"
%   \ritoArechts
%   \rechtsCoupletA
  \rechtsCoupletAweiter
} %ende rechts

links = { 
  
  \kreuzAn
%   \ritoAlinks
%   \linksCoupletA
   \linksCoupletAweiter

} %ende links
dynamik = { 
%   \dynaritoA
%   \dynaCoupletA % Dieses muss evtl. noch später hinzugefügt werden!
   \dynaCoupletAweiter
} %ende Dynamik
 pedal = {
%    \pedritoA 
%    \pedCoupletA
    \pedCoupletAweiter
 }
 
%%%%%%%%% Jetzt kommt das Layout!
  \layout {
    % Definiert den Kontext,in dem Dynamik und Taktangaben notiert sind
    \context {
      \type "Engraver_group"
      \name Dynamics
      \alias Voice
      \consists "Output_property_engraver" %keine Ahnung, was das bedeuten soll!
      \consists "Script_engraver"
      \consists "New_dynamic_engraver"
      \consists "Dynamic_align_engraver"
      \consists "Text_engraver"
      \consists "Skip_event_swallow_translator"
      \consists "Axis_group_engraver"
   \consists "Text_spanner_engraver"
%       \override DynamicLineSpanner #'Y-offset = #0
      \override TextScript #'font-size = #2
      \override TextScript #'font-shape = #'italic
        \override TextScript #'Y-offset = #0
      \override DynamicLineSpanner #'Y-offset = #0

     \override VerticalAxisGroup #'minimum-Y-extent = #'(-1 . 1)

      %diesen Werke
    }
    % Definiert den Kontext,in dem das Pedal notiert wird
    \context {
      \type "Engraver_group"
      \name Pedal
      \alias Voice
      \consists "Output_property_engraver" %keine Ahnung, was das bedeuten soll!
      \consists "Piano_pedal_engraver"
      \consists "Dynamic_align_engraver"
      \consists "Text_engraver"
      \consists "Skip_event_swallow_translator"
      \consists "Axis_group_engraver"
   \consists "Text_spanner_engraver"
      pedalSustainStrings = #'("Ped." "*Ped." "*")
      pedalUnaCordaStrings = #'("una corda" "" "tre corde")
      %\override TextScript #'font-size = #2
     % \override TextScript #'font-shape = #'italic
      \override VerticalAxisGroup #'minimum-Y-extent = #'(-1 . 1)
    }
    % modify PianoStaff context to accept Dynamics context
    \context {
      \PianoStaff
      \accepts Dynamics
        \accepts Pedal
    }
        \context {  \Pedal \override PianoPedalBracket #'style = #'bracket }
        \context { \Score \override TimeSignature #'style = #'( ) } %Viervierteltakte ohne Halbkreis
  }


\score {
  \new PianoStaff = "Klavier" <<
    \new Staff = "rechts" \rechts
    \new Dynamics = "Dynamics_pf" \dynamik
    \new Staff = "links"  \links 
    \new Pedal = "pedal" { \set pedalSustainStyle = #'mixed  \pedal }
  >> 
           \layout { }
%             \midi { }
        }




